CON
  _CLKMODE = xtal1 + pll16x
  _XINFREQ = 5_000_000 

OBJ
  synth : "tinysynth"
 
PUB main
  synth.start(10, 11)

  repeat
    testFilter
    waitcnt(cnt+80_000_000)
    testVolume
    waitcnt(cnt+80_000_000)
    testLockedPulseWidth
    waitcnt(cnt+80_000_000)
    testDecayRate
    waitcnt(cnt+80_000_000)
    testNoteOnOffAndPortamento
    waitcnt(cnt+80_000_000)









































CON
  tb1_pwinit = 256, tb1_pwmRate= 12, tb1_decRate= 16, tb1_susLevel = 64
      
PUB testFilter

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)       
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 1)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 2)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 3)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 4)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 5) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 6)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 7)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 8)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 9)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,10)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,11)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,12)          
    waitcnt(cnt+20_000_000)

CON
  tb2_pwinit = 256,tb2_pwmRate = 0,tb2_decRate = 16, tb2_susLevel = 64, tb2_filtLevel = 1
      
PUB testVolume

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)        
    synth.pluck(20, tb2_decRate, 4,  tb2_pwinit, tb2_pwmRate, tb2_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, 8,  tb2_pwinit, tb2_pwmRate, tb2_filtLevel)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, 12, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, 16, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, 20, tb2_pwinit, tb2_pwmRate, tb2_filtLevel) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb2_decRate, 24, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, 28, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, 32, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, 36, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb2_decRate, 42, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, 46, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, 52, tb2_pwinit, tb2_pwmRate, tb2_filtLevel)          
    waitcnt(cnt+20_000_000)

CON
  tb3_pwinit = 256,tb3_pwmRate = 0,tb3_decRate = 16, tb3_susLevel = 64, tb3_filtLevel = 0
      
PUB testLockedPulseWidth

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)        
    synth.pluck(20, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel)          
    waitcnt(cnt+20_000_000)

CON
  tb4_pwinit = 256,tb4_pwmRate = 0,tb4_decRate = 16, tb4_susLevel = 64, tb4_filtLevel = 0
   
PUB testDecayRate

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)        
    synth.pluck(20, 13, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 13, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 14, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 14, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 15, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, 15, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 16, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 16, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 17, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, 17, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 18, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 18, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel)          
    waitcnt(cnt+20_000_000)

CON
  tb5_pwinit = 12, tb5_pwmRate = 3, tb5_attRate = 19, tb5_decRate = 18, tb5_susLevel = 60, tb5_filtLevel = 6
   
PUB testNoteOnOffAndPortamento

    'noteOn(midiNote, attackRate, sustainLevel, pulseWidthInit, pwmRate, fil)  
    synth.noteOn(30, tb5_attRate, tb5_susLevel, tb5_pwinit, tb5_pwmRate, tb5_filtLevel)         
    waitcnt(cnt+20_000_000)

    'slideToNote(midiNote, slideRate) 
    synth.slideToNote(42, 11)            
    waitcnt(cnt+30_000_000)
    synth.slideToNote(30, 11)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(42, 12)             
    waitcnt(cnt+30_000_000)
    synth.slideToNote(40, 12) 
    waitcnt(cnt+30_000_000)
    synth.slideToNote(52, 13)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(40, 13)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(52, 14)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(40, 14)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(52, 14)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(50, 15)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(62, 15)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(50, 16)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(62, 16)          
    waitcnt(cnt+30_000_000)

    'noteOff(decayRate)
    synth.noteOff(tb5_decRate)         
    waitcnt(cnt+20_000_000)
                                                         